﻿Global NewList fontData.s()
Global intHeight.l
Global intBaseLine.l
Global intCommentLines.l
Global strHardBlank.s
Global fontok.l=1
Global cntr.l=0
Enumeration
  #r
  #f
  #t
EndEnumeration

Procedure.s GetCharacter(char.s, intLine)
  intAscii= Asc(char)
  intStart = intCommentLines + ((intAscii - 32) * intHeight)
  If intStart+intLine>ListSize(fontData()) Or intAscii>127
    intStart = intCommentLines + ((63- 32) * intHeight)
  EndIf  
  SelectElement(fontData(), intStart + intLine)
  strTmp.s = fontData()
  strTmp = ReplaceString(strTmp, "@", "")
  strTmp = ReplaceString(strTmp, strHardBlank, " ")
  ProcedureReturn strTmp
  
EndProcedure


Procedure Load_Font()
  
  fontok=1
  fontFile.s=GetGadgetText(#f)
  cntr = 0
  If fontFile=""
    MessageRequester("font","wrong font name")
    fontok=0
  EndIf
  If ReadFile(0,GetCurrentDirectory()+"fonts\"+fontFile+".flf")
    ClearList(fontData())
    While Not Eof(0)
      AddElement(fontData())
      fontData()=ReadString(0,#PB_Ascii)
      cntr+1
    Wend
    CloseFile(0)
  Else
    MessageRequester("load font","error reading "+fontFile)
    fontok=0
  EndIf
  
  ;flf2a$ 6 5 10 0 13
  ; flf2 - "magic number" For file identification
  ; a    - should always be `a', for now
  ; $    - the "hardblank" -- prints As a blank, but can't be smushed
  ; 6    - height of a character
  ; 5    - height of a character, Not including descenders
  ; 20   - max line length (excluding comment lines) + a fudge factor
  ; 15   - Default smushmode For this font (like "-m 15" on command line)
  ; 13   - number of comment lines
  
  SelectElement(fontData(), 0)
  arrTmp.s=fontData()
  ubnd=CountString(arrTmp, " ")
  strTmp.s=StringField(arrTmp,1," ")
  strSignature.s=Mid(strTmp,1,Len(strtmp)-1)
  strHardBlank.s=Right(strtmp, 1)
  
  intHeight.l=Val(StringField(arrTmp,2," "));height of a character
  intBaseLine.l=Val(StringField(arrTmp,3," "));height of a character, Not including descenders
  intMaxLen.l=Val(StringField(arrTmp,4," "))
  intOldLayout.l=Val(StringField(arrTmp,5," "))
  intCommentLines.l=Val(StringField(arrTmp,6," "))
  If uBnd > 5
    intPrintDirection.l=Val(StringField(arrTmp,6," "))
  EndIf
  
  If uBnd > 6
    intFullLayout.l=Val(StringField(arrTmp,7," "))
  EndIf
  If uBnd > 7
    intCodeTagCount.l=Val(StringField(arrTmp,8," "))
  EndIf
  
  If LCase(strSignature)<>"flf2a"
    MessageRequester("font","not a Figlet font")
    fontok=0
  EndIf
  
  ;   Debug cntr/intHeight - intCommentLines
  
EndProcedure


Procedure Display()
  strText.s=GetGadgetText(#t)
  r$=""
  For cnt = 1 To intHeight
    For idx = 1 To Len(strText)
      char.s = Mid(strText, idx, 1)
      r$=r$+GetCharacter(char, cnt)
    Next idx
    r$+#CRLF$
  Next cnt
  SetGadgetText(#r,r$)
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "Figlet", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#r, 0,  20, 640, 460, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL)
  ComboBoxGadget(#f,0,0,100,20)
  StringGadget(#t, 100, 0, 540, 20, "");+Chr(255))
  If ExamineDirectory(0, GetCurrentDirectory()+"fonts\", "*.flf")  
    While NextDirectoryEntry(0)
      If DirectoryEntryType(0) = #PB_DirectoryEntry_File
        AddGadgetItem(#f, -1, GetFilePart(DirectoryEntryName(0),#PB_FileSystem_NoExtension))
      EndIf
    Wend
    FinishDirectory(0)
  EndIf
  SetGadgetState(#f,1)
  GadgetToolTip(#r,"Result")
  GadgetToolTip(#f,"choose font")
  GadgetToolTip(#t,"type text")
  If LoadFont(1, "Courier", 5)
    SetGadgetFont(#r, FontID(1))
  Else
    Debug "font load error"
  EndIf
  
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select ev
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #t
            If EventType()=#PB_EventType_Change
              If fontok
                display()
              EndIf
            EndIf
          Case #f
            If EventType()=#PB_EventType_Change
              load_font()
              display()
            EndIf
        EndSelect
        
        ;        Case #PB_Event_Menu
        ;          Select EventMenu()
        ;            Case 1 : Debug "Menu item 1 clicked!"
        ;            Case 2 : Debug "Menu item 2 clicked!"
        ;            Case 3 : Debug "Menu item 3 clicked!"
        ;         EndSelect
        
    EndSelect
    
  Until ev = #PB_Event_CloseWindow
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 34
; FirstLine = 28
; Folding = -
; EnableXP
; UseIcon = figlet.ico
; Executable = figlet.exe